import { Clauses, MagnetarPlugin } from '@magnetarjs/types';

interface Vue2StoreOptions {
    /**
     * This is required to make sure there are not two instances of Vue running which can cause issues.
     */
    vueInstance: any;
    /**
     * To support optimistic UI you need to provide a function that can generate unique IDs.
     * @example () => firestore.collection('random').doc().id
     */
    generateRandomId: () => string;
}
interface Vue2StoreModuleConfig extends Clauses {
    path?: string;
    initialData?: Record<string, unknown> | [string, Record<string, unknown>][];
}
/**
 * a Magnetar plugin is a single function that returns a `PluginInstance`
 * the plugin implements the logic for all actions that a can be called from a Magnetar module instance
 * each action must have the proper for both collection and doc type modules
 */
declare const CreatePlugin: MagnetarPlugin<Vue2StoreOptions>;

export { CreatePlugin, Vue2StoreModuleConfig, Vue2StoreOptions };
